/*---------------------------------------------------------------------------
     File name    : CustomToolTip.h
     Author       : William Baxter
     Created      : 8/5/2003
  
     Description  : Tooltip subclass that supports maybe not rich text, but
                    at least upper-middle class text.
  --------------------------------------------------------------------------*/
#ifndef _CUSTOMTOOLTIP_H
#define _CUSTOMTOOLTIP_H

#include <fx.h>

class CustomToolTip : public FXToolTip
{
  FXDECLARE(CustomToolTip)
protected:
  CustomToolTip() : FXToolTip() {}
private:
  CustomToolTip(const CustomToolTip&);
  CustomToolTip& operator=(const CustomToolTip&);
public:
  long onPaint(FXObject*,FXSelector,void*);

public:
  /// Construct a tool tip
  CustomToolTip(FXApp* a,FXuint opts=TOOLTIP_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0)
    : FXToolTip(a,opts,x,y,w,h) {}
  /// Return default width
  virtual FXint getDefaultWidth();

  void setStyle( FXuint toolstyle ) {
    options &=  ~(TOOLTIP_NORMAL|TOOLTIP_PERMANENT|TOOLTIP_VARIABLE);
    options |=   toolstyle&(TOOLTIP_NORMAL|TOOLTIP_PERMANENT|TOOLTIP_VARIABLE);
  }
  FXuint getStyle( ) const { 
    return options&(TOOLTIP_NORMAL|TOOLTIP_PERMANENT|TOOLTIP_VARIABLE);
  }


};
 

#endif // _CUSTOMTOOLTIP_H
