#include "ImdebugImageView.h"

FXDEFMAP(ImdebugImageView) ImdebugImageViewMap[]={
  FXMAPFUNC(SEL_UPDATE,FXWindow::ID_QUERY_TIP,ImdebugImageView::onQueryTip),
  FXMAPFUNC(SEL_UPDATE,FXWindow::ID_QUERY_HELP,ImdebugImageView::onQueryHelp)
  };


// Object implementation
FXIMPLEMENT(ImdebugImageView,FXImageFrame,ImdebugImageViewMap,ARRAYNUMBER(ImdebugImageViewMap))

// Deserialization
ImdebugImageView::ImdebugImageView()
{
}


// Construct it
ImdebugImageView::ImdebugImageView(
  FXComposite* p,FXImage *img,FXuint opts,
  FXint x,FXint y,FXint w,FXint h,
  FXint pl,FXint pr,FXint pt,FXint pb)
     :
  FXImageFrame(p,img,opts,x,y,w,h,pl,pr,pt,pb)
{
  
}

// Change help text
void ImdebugImageView::setHelpText(const FXString& text){
  statusHelpText=text;
  if (!text.empty()) flags |= FLAG_HELP;
}


// Change tip text
void ImdebugImageView::setTipText(const FXString& text){
  tooltipText=text;
  if (!text.empty()) flags |= FLAG_TIP;
  
}


// We were asked about status text
long ImdebugImageView::onQueryHelp(FXObject* sender,FXSelector,void*){
  if(!statusHelpText.empty() && (flags&FLAG_HELP)){
    sender->handle(this,FXSEL(SEL_COMMAND,ID_SETSTRINGVALUE),&statusHelpText);
    return 1;
  }
  return 0;
}


// We were asked about tip text
long ImdebugImageView::onQueryTip(FXObject* sender,FXSelector,void*){
  if(!tooltipText.empty() && (flags&FLAG_TIP)){
    sender->handle(this,FXSEL(SEL_COMMAND,ID_SETSTRINGVALUE),&tooltipText);
    return 1;
  }
  return 0;
}


