/*---------------------------------------------------------------------------
     File name    : ImdebugImageView.h
     Author       : William Baxter
     Created      : 8/5/2003
  
     Description  : 
  --------------------------------------------------------------------------*/
#ifndef _IMDEBUGIMAGEVIEW_H
#define _IMDEBUGIMAGEVIEW_H


#include <fx.h>

class ImdebugImageView : public FXImageFrame
{
  FXDECLARE(ImdebugImageView)
protected:
  FXString statusHelpText;
  FXString tooltipText;
protected:
  ImdebugImageView();
private:
  ImdebugImageView(const ImdebugImageView&);
  ImdebugImageView &operator=(const ImdebugImageView&);
public:
  
  /// Construct Imdebug image frame
  ImdebugImageView(
    FXComposite* p,FXImage *img,
    FXuint opts=FRAME_SUNKEN|FRAME_THICK,
    FXint x=0,FXint y=0,FXint w=0,FXint h=0,
    FXint pl=0,FXint pr=0,FXint pt=0,FXint pb=0
    );
  
  void setHelpText(const FXString &);
  void setTipText(const FXString &);
public:
  long onQueryTip(FXObject*sender,FXSelector sel, void*ptr);
  long onQueryHelp(FXObject*sender,FXSelector sel, void*ptr);
  
};


#endif // _IMDEBUGIMAGEVIEW_H
